<template>
  <v-container
    fluid
    tag="section"
  >
    <material-card
      icon="mdi-archive-arrow-down"
      icon-small
      :title="$t('recepciones')"
      color="secondary"
    >
      <v-row>
        <v-col cols="12" md="4" sm="12">
          <h3 class="pl-6 pt-3">Pedido Nro: {{ pedidoId }}</h3>
        </v-col>
        <v-col cols="12" md="4" sm="12">
          <v-btn
            class="mt-2 mr-4"
            color="primary"
            rounded
            small
            @click="terminar"
            :disabled="loading"
          >
            <v-icon>mdi-check</v-icon>
            {{ $t('terminar') }}
          </v-btn>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <v-data-table
            v-model="selected"
            :headers="headers"
            :items="detallePedido"
            item-key="id"
            class="elevation-1"
            disable-pagination
            hide-default-footer
            dense
            :loading="loading"
          >
            <template v-slot:item.cantidad="props">
              <v-edit-dialog
                :return-value.sync="props.item.cantidad"
                large
                :cancel-text="$t('cancelar')"
                :save-text="$t('guardar')"
                @save="guardarCantidad(props.item.id)"
              >
                <v-chip
                  class="ma-2"
                  :color="setCantidad(props.item)"
                >
                  {{ props.item.cantidad }}
                </v-chip>
                <template v-slot:input>
                  <div class="mt-4 text-h6">
                    {{ $t('editarCantidad') }}
                  </div>
                  <v-text-field
                    v-model="props.item.cantidad"
                    :label="$t('editar')"
                    :rules="[props.item.cantidad < props.item.cantidad_disponible || 'error']"
                    single-line
                    autofocus
                    type="number"
                    hide-details="auto"
                  ></v-text-field>
                </template>
              </v-edit-dialog>
            </template>

          </v-data-table>
        </v-col>
      </v-row>
      <FramePdf
        :fileUrl="filePdf"
        :dialog="dialog"
        @onCloseDialog="closeDialog"
      />
    </material-card>
  </v-container>
</template>

<script>
import PedidoServicio from '@/store/services/PedidoServicio'
export default {
  components: {
  },data () {
    return {
      pedidoId: null,
      detallePedido: [],
      loading: false,
      selected: [],
      form: {
        cantidad: 0
      },
      filePdf: null,
      dialog: false
    }
  },
  methods: {
    init () {
      this.pedidoId = this.$route.params.id
      this.getDetalle()
    },
    async getDetalle() {
      this.loading = true
      try {
        let response = await PedidoServicio.detalleTotal(this.pedidoId)
        this.detallePedido = response.data
        this.loading = false
      } catch (error) {
        this.loading = false
        console.log(error)
      }
    },
    guardarCantidad() {

    },
    setCantidad(value) {
      let cantidad = value.cantidad_disponibled - value.cantidad
      return cantidad > 0 ? 'error' : 'success'
    },
    async terminar() {
      try {
        let response = await PedidoServicio.terminar(this.pedidoId, this.detallePedido, {
          responseType: 'blob',
          Accept: 'application/pdf',
        })
        const url = window.URL.createObjectURL(new Blob([response.data], {type: 'application/pdf'}));
        this.filePdf = url
        this.dialog = true
      } catch (error) {
        alert('La cantidad debe ser menor o igual a la cantidad disponible')
      }
    },
    closeDialog() {
      this.dialog = false
      this.$router.push({name: 'pedidos'})
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('descripcion'),
          value: 'descripcion',
          sortable: false,
        },
        {
          text: this.$t('cantidad'),
          value: 'cantidad',
          sortable: false,
          align: 'center'
        },
        {
          text: this.$t('unidManejo'),
          value: 'unid_manejo',
          sortable: false,
        },
        {
          text: this.$t('marca'),
          value: 'marca',
          sortable: false,
        },
        {
          text: this.$t('cantidadDisponible'),
          value: 'cantidad_disponible',
          sortable: false,
        },
      ];
    },
  },
  // created() {
  //   console.log(this.$router)
  //   this.pedidoId = this.$router.params.id
  // },
  mounted () {
    this.init()
  },
}
</script>

<style>

</style>
